package com.tmax.openframe.variable.group;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @AllArgsConstructor @NoArgsConstructor @Builder(builderClassName = "builder") class OFCB001_IN_REC {
    public @Getter @Builder.Default String IN_CUSTOMER_NUMBER = StringUtils
            .repeat(' ', 6);
    public @Getter @Builder.Default String IN_FIRST_NAME = StringUtils.repeat(
            ' ', 20);
    public @Getter @Builder.Default String IN_LAST_NAME = StringUtils.repeat(
            ' ', 30);
    public @Getter @Builder.Default String IN_ADDRESS = StringUtils.repeat(' ',
            30);
    public @Getter @Builder.Default String IN_CITY = StringUtils
            .repeat(' ', 20);
    public @Getter @Builder.Default String IN_STATE = StringUtils
            .repeat(' ', 2);
    public @Getter @Builder.Default String IN_ZIP_CODE = StringUtils.repeat(
            ' ', 10);
    public @Getter @Setter int IN_LAST_UPDATE;
    private final static BiFunction<Long, String, String> intFormatWithoutSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.setNegativePrefix("");
        nf.applyPattern(format);
        return nf.format(value);
    };

    public void setIN_CUSTOMER_NUMBER(String source) {
        IN_CUSTOMER_NUMBER = StringUtils.truncate(
                StringUtils.rightPad(source, 6), 6);
    }

    public void setIN_FIRST_NAME(String source) {
        IN_FIRST_NAME = StringUtils.truncate(StringUtils.rightPad(source, 20),
                20);
    }

    public void setIN_LAST_NAME(String source) {
        IN_LAST_NAME = StringUtils.truncate(StringUtils.rightPad(source, 30),
                30);
    }

    public void setIN_ADDRESS(String source) {
        IN_ADDRESS = StringUtils.truncate(StringUtils.rightPad(source, 30), 30);
    }

    public void setIN_CITY(String source) {
        IN_CITY = StringUtils.truncate(StringUtils.rightPad(source, 20), 20);
    }

    public void setIN_STATE(String source) {
        IN_STATE = StringUtils.truncate(StringUtils.rightPad(source, 2), 2);
    }

    public void setIN_ZIP_CODE(String source) {
        IN_ZIP_CODE = StringUtils
                .truncate(StringUtils.rightPad(source, 10), 10);
    }

    public String getStringIN_LAST_UPDATE() {
        return intFormatWithoutSign.apply((long) IN_LAST_UPDATE, "00000000");
    }

    @Override
    public String toString() {
        return getIN_CUSTOMER_NUMBER() + getIN_FIRST_NAME() + getIN_LAST_NAME()
                + getIN_ADDRESS() + getIN_CITY() + getIN_STATE()
                + getIN_ZIP_CODE() + getStringIN_LAST_UPDATE();
    }
}
